Redmine - Patch #10464

Enhanced PDF output for Issues list
2012-03-16 09:26 - Yuri Makarov

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: PDF export Estimated time: 0.00 hour
Target version: 1.4.0

Description

Improvements:

1. Automatic calculation of the size of table columns depending on their content.

2. Automatic detection of columns alignment.

3. Output table header on each page.

Related issues:

Related to Redmine - Defect #10554: Defect symbols when exporting tasks in pdf Closed

Associated revisions

Revision 9246 - 2012-03-20 08:09 - Toshi MARUYAMA
pdf: enhanced issues list (#10464)

e Automatic calculation of the size of table columns depending on their content
¢ Qutput table header on each page

Contributed by Yuri Makarov.

History

#1 - 2012-03-16 10:47 - Yuri Makarov
- File example-1.pdf added
- File example-2.pdf added
- File example-3.pdf added

#2 - 2012-03-17 06:36 - Toshi MARUYAMA
- File pdf-r9240.diff added

This is a patch rebased on trunk r9240.

#3 - 2012-03-18 09:02 - Toshi MARUYAMA
- File issues-pdf-r9244.diff added

This is a full patch for r9244 which fixes conflict and source indents.

#4 - 2012-03-18 09:30 - Toshi MARUYAMA
- File grouped-issues.pdf added
- File first-row.png added

Note 3 patch first row of second page height is broken.

2025-07-16

1/3



https://www.redmine.org/projects/redmine/repository/svn/revisions/9240
https://www.redmine.org/projects/redmine/repository/svn/revisions/9244

# Project Tracker | Statu

26 hg-crew-00 Bug New

25 hg-crew-00 Bug New
(41)

24 hg-crew-00 Bug New
(41)

23 hg-crew-00 Bug New
(41)

#5 - 2012-03-18 10:27 - Yuri Makarov

| can't test it now, my Redmine at work.

Some comments:

1. Comparing the diff's, | see in my pdf.rb line:
cv = issue.custom_values.detect {[ v | ....

your version should be?:

cv = issue.custom_field_values.detect {| v | ....

2. Calculate the length of the text in my diff is based on the font page header. This is not correct. It almost does not affect the result, but leads to an
increase in long columns of text. To correct this, use in def calc_col_width:

# by captions
pdf.SetFontStyle('B',8)

# by properties of issues
pdf.SetFontStyle(",8)

In this case, it may be necessary to add a constant of the column width for padding around the text, such as 5 mm.
col_padding =5
col_width_min = query.columns.map {|v| pdf.GetStringWidth(v.caption) + col_padding}

x = pdf.GetStringWidth(w) + col_padding
n = pdf.GetStringWidth(v.rstrip) + col_padding

x = pdf.GetStringWidth(w) + col_padding

#6 - 2012-03-18 10:32 - Toshi MARUYAMA

Please create a patch to the trunk.
| rebased your patch to the trunk.

#7 - 2012-03-18 12:14 - Yuri Makarov

| can make a patch only tomorrow at work.

About first row of second page ..
Change from (about line 333 in trunk):

# make new page if it doesn't fit on the current one
space_left = page_height - base_y - bottom_margin
if max_height > space_left
pdf.AddPage ("L")
base_x = pdf.GetX
base_y = pdf.GetY
render_table_header (pdf, query, col_width, row_height, col_id_width, table_width)
end

To:

# make new page if it doesn't fit on the current one
space_left = page_height - base_y - bottom_margin
if max_height > space_left
pdf.AddPage ("L")
render_table_header (pdf, query, col_width, row_height, col_id_width, table_width)
base_x = pdf.GetX
base_y = pdf.GetY
end
This should fix the result.

#8 - 2012-03-19 11:37 - Yuri Makarov
- File pdf-1.diff added

Updated

#9 - 2012-03-19 23:09 - Terence Mill

+1

#10 - 2012-03-20 08:15 - Toshi MARUYAMA
- File pdf-issues-alignment.diff added
- Status changed from New to Closed

- Target version set to 1.4.0

| committed r9246 to the trunk.

This commit is removed auto alignment.

| attach a patch for auto alignment.

| do not see the reason to change alignment.

Files

pdf.diff 9.09 KB 2012-03-16 Yuri Makarov
example-1.pdf 17.6 KB 2012-03-16 Yuri Makarov
example-2.pdf 329 KB 2012-03-16 Yuri Makarov
example-3.pdf 14.5 KB 2012-03-16 Yuri Makarov
pdf-r9240.diff 9.98 KB 2012-03-17 Toshi MARUYAMA
issues-pdf-r9244.diff 10.2 KB 2012-03-18 Toshi MARUYAMA
grouped-issues.pdf 416 KB 2012-03-18 Toshi MARUYAMA
first-row.png 13 KB 2012-03-18 Toshi MARUYAMA
pdf-1.diff 9.67 KB 2012-03-19 Yuri Makarov
pdf-issues-alignment.diff 1.54 KB 2012-03-20 Toshi MARUYAMA
